# Partition an array of non-negative integers into two subsets such that average of both the subsets is equal

Given an array of size **N**. The task is to partition the given array into two subsets such that the average of all the elements in both subsets is equal. If no such partition exists print -1. Otherwise, print the partitions. If multiple solutions exist, print the solution where the length of the first subset is minimum. If there is still a tie then print the partitions where the first subset is lexicographically smallest.

**Examples:**

Input :vec[] = {1, 7, 15, 29, 11, 9}Output :[9, 15] [1, 7, 11, 29]Explanation :Average of the both the subsets is 12Input :vec[] = {1, 2, 3, 4, 5, 6}Output :[1, 6] [2, 3, 4, 5].Explanation :Another possible solution is [3, 4] [1, 2, 5, 6], but print the solution whose first subset is lexicographically smallest.

**Observation :**

If we directly compute the average of a certain subset and compare it with another subset’s average, due to precision issues with compilers, unexpected results will occur. For example, 5/3 = 1.66666.. and 166/100 = 1.66. Some compilers might treat them as same, whereas some others won’t.

Let the sum of two subsets under consideration be sub1 and sub2, and let their sizes be s1 and s2. If their averages are equal, sub1/s1 = sub2/s2 . Which means sub1*s2 the = sub2*s1.

Also total sum of the above two subsets = sub1+sub2, and s2= total size – s1.

On simplifying the above, we get

(sub1/s1) = (sub1+sub2)/ (s1+s2) = (total sum) / (total size).

Now this problem reduces to the fact that if we can select a particular size

of subset whose sum is equal to the current subset’s sum, we are done.

**Approach :**

Let us define the function partition(ind, curr_sum, curr_size), which returns true if it is possible to construct subset using elements with index equals to ind and having size equals to curr_size and sum equals to curr_sum.

This recursive relation can be defined as:

partition(ind, curr_sum, curr_size) = partition(ind+1, curr_sum, curr_size) || partition(ind+1, curr_sum – val[ind], curr_size-1).

Two parts on the right side of the above equations represent whether we including the element at index **ind** or not.

This is a deviation from the classic subset sum problem, in which subproblems are being evaluated again and again. Therefore we memorize the subproblems and turn it into a Dynamic Programming solution.

`// CPP program to Partition an array of ` `// non-negative integers into two subsets ` `// such that average of both the subsets are equal ` `#include <bits/stdc++.h> ` `using` `namespace` `std; ` ` ` `vector<vector<vector<` `bool` `> > > dp; ` `vector<` `int` `> res; ` `vector<` `int` `> original; ` `int` `total_size; ` ` ` `// Function that returns true if it is possible to ` `// use elements with index = ind to construct a set of s ` `// ize = curr_size whose sum is curr_sum. ` `bool` `possible(` `int` `index, ` `int` `curr_sum, ` `int` `curr_size) ` `{ ` ` ` `// base cases ` ` ` `if` `(curr_size == 0) ` ` ` `return` `(curr_sum == 0); ` ` ` `if` `(index >= total_size) ` ` ` `return` `false` `; ` ` ` ` ` `// Which means curr_sum cant be found for curr_size ` ` ` `if` `(dp[index][curr_sum][curr_size] == ` `false` `) ` ` ` `return` `false` `; ` ` ` ` ` `if` `(curr_sum >= original[index]) { ` ` ` `res.push_back(original[index]); ` ` ` `// Checks if taking this element at ` ` ` `// index i leads to a solution ` ` ` `if` `(possible(index + 1, curr_sum - ` ` ` `original[index], ` ` ` `curr_size - 1)) ` ` ` `return` `true` `; ` ` ` ` ` `res.pop_back(); ` ` ` `} ` ` ` `// Checks if not taking this element at ` ` ` `// index i leads to a solution ` ` ` `if` `(possible(index + 1, curr_sum, curr_size)) ` ` ` `return` `true` `; ` ` ` ` ` `// If no solution has been found ` ` ` `return` `dp[index][curr_sum][curr_size] = ` `false` `; ` `} ` ` ` `// Function to find two Partitions having equal average ` `vector<vector<` `int` `> > partition(vector<` `int` `>& Vec) ` `{ ` ` ` `// Sort the vector ` ` ` `sort(Vec.begin(), Vec.end()); ` ` ` `original.clear(); ` ` ` `original = Vec; ` ` ` `dp.clear(); ` ` ` `res.clear(); ` ` ` ` ` `int` `total_sum = 0; ` ` ` `total_size = Vec.size(); ` ` ` ` ` `for` `(` `int` `i = 0; i < total_size; ++i) ` ` ` `total_sum += Vec[i]; ` ` ` `// building the memoization table ` ` ` `dp.resize(original.size(), vector<vector<` `bool` `> > ` `(total_sum + 1, vector<` `bool` `>(total_size, ` `true` `))); ` ` ` ` ` `for` `(` `int` `i = 1; i < total_size; i++) { ` ` ` `// Sum_of_Set1 has to be an integer ` ` ` `if` `((total_sum * i) % total_size != 0) ` ` ` `continue` `; ` ` ` `int` `Sum_of_Set1 = (total_sum * i) / total_size; ` ` ` ` ` `// We build our solution vector if its possible ` ` ` `// to find subsets that match our criteria ` ` ` `// using a recursive function ` ` ` `if` `(possible(0, Sum_of_Set1, i)) { ` ` ` ` ` `// Find out the elements in Vec, not in ` ` ` `// res and return the result. ` ` ` `int` `ptr1 = 0, ptr2 = 0; ` ` ` `vector<` `int` `> res1 = res; ` ` ` `vector<` `int` `> res2; ` ` ` `while` `(ptr1 < Vec.size() || ptr2 < res.size()) ` ` ` `{ ` ` ` `if` `(ptr2 < res.size() && ` ` ` `res[ptr2] == Vec[ptr1]) ` ` ` `{ ` ` ` `ptr1++; ` ` ` `ptr2++; ` ` ` `continue` `; ` ` ` `} ` ` ` `res2.push_back(Vec[ptr1]); ` ` ` `ptr1++; ` ` ` `} ` ` ` ` ` `vector<vector<` `int` `> > ans; ` ` ` `ans.push_back(res1); ` ` ` `ans.push_back(res2); ` ` ` `return` `ans; ` ` ` `} ` ` ` `} ` ` ` `// If we havent found any such subset. ` ` ` `vector<vector<` `int` `> > ans; ` ` ` `return` `ans; ` `} ` ` ` `// Function to print partitions ` `void` `Print_Partition(vector<vector<` `int` `> > sol) ` `{ ` ` ` `// Print two partitions ` ` ` `for` `(` `int` `i = 0; i < sol.size(); i++) { ` ` ` `cout << ` `"["` `; ` ` ` `for` `(` `int` `j = 0; j < sol[i].size(); j++) { ` ` ` `cout << sol[i][j]; ` ` ` `if` `(j != sol[i].size() - 1) ` ` ` `cout << ` `" "` `; ` ` ` `} ` ` ` `cout << ` `"] "` `; ` ` ` `} ` `} ` ` ` `// Driver code ` `int` `main() ` `{ ` ` ` `vector<` `int` `> Vec = { 1, 7, 15, 29, 11, 9 }; ` ` ` ` ` `vector<vector<` `int` `> > sol = partition(Vec); ` ` ` ` ` `// If partition possible ` ` ` `if` `(sol.size()) ` ` ` `Print_Partition(sol); ` ` ` `else` ` ` `cout << -1; ` ` ` ` ` `return` `0; ` `} ` |

*chevron_right*

*filter_none*

**Output:**

[9 15] [1 7 11 29]

## Recommended Posts:

- Sum of average of all subsets
- Closest sum partition (into two subsets) of numbers from 1 to n
- Count number of ways to partition a set into k subsets
- Partition a set into two subsets such that the difference of subset sums is minimum
- Sum of subsets of all the subsets of an array | O(2^N)
- Sum of subsets of all the subsets of an array | O(3^N)
- Sum of subsets of all the subsets of an array | O(N)
- Count of all possible pairs of disjoint subsets of integers from 1 to N
- Count of subsets with sum equal to X
- Divide first N natural numbers into 3 equal sum subsets
- Maximum average sum partition of an array
- Sum of squares of all Subsets of given Array
- Sum of values of all possible non-empty subsets of the given array
- Maximum possible difference of two subsets of an array
- Product of values of all possible non-empty subsets of given Array

If you like GeeksforGeeks and would like to contribute, you can also write an article using contribute.geeksforgeeks.org or mail your article to contribute@geeksforgeeks.org. See your article appearing on the GeeksforGeeks main page and help other Geeks.

Please Improve this article if you find anything incorrect by clicking on the "Improve Article" button below.